--- vcl.orig/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 12:34:41.000000000 +0100
+++ vcl/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 13:19:37.000000000 +0100
@@ -1470,54 +1475,54 @@
     button12BoundRect.Move( -rControlRectangle.Left(), -rControlRectangle.Top() );
     button21BoundRect.Move( -rControlRectangle.Left(), -rControlRectangle.Top() );
 
-	NWEnsureGTKButton( m_nScreen );
-	NWEnsureGTKScrollbars( m_nScreen );
-	NWEnsureGTKArrow( m_nScreen );
+    NWEnsureGTKButton( m_nScreen );
+    NWEnsureGTKScrollbars( m_nScreen );
+    NWEnsureGTKArrow( m_nScreen );
  
-	// Find the overall bounding rect of the control
-	pixmapRect = rControlRectangle;
+    // Find the overall bounding rect of the control
+    pixmapRect = rControlRectangle;
     pixmapRect.SetSize( Size( pixmapRect.GetWidth() + 1,
                               pixmapRect.GetHeight() + 1 ) );
-	scrollbarRect = pixmapRect;
+    scrollbarRect = pixmapRect;
 
-	if ( (scrollbarRect.GetWidth() <= 1) || (scrollbarRect.GetHeight() <= 1) )
-		return( TRUE );
+    if ( (scrollbarRect.GetWidth() <= 1) || (scrollbarRect.GetHeight() <= 1) )
+        return( TRUE );
 
-	// Grab some button style attributes
-	gtk_widget_style_get( gWidgetData[m_nScreen].gScrollHorizWidget,
+    // Grab some button style attributes
+    gtk_widget_style_get( gWidgetData[m_nScreen].gScrollHorizWidget,
                                       "slider_width", &slider_width,
-									  "stepper_size", &stepper_size,
-									  "trough_border", &trough_border,
-									  "stepper_spacing", &stepper_spacing,
-									  "min_slider_length", &min_slider_length, (char *)NULL );
+                                      "stepper_size", &stepper_size,
+                                      "trough_border", &trough_border,
+                                      "stepper_spacing", &stepper_spacing,
+                                      "min_slider_length", &min_slider_length, (char *)NULL );
     gboolean has_forward;
     gboolean has_forward2;
     gboolean has_backward;
     gboolean has_backward2;
     
-	gtk_widget_style_get( gWidgetData[m_nScreen].gScrollHorizWidget, "has-forward-stepper", &has_forward,
-									  "has-secondary-forward-stepper", &has_forward2,
-									  "has-backward-stepper", &has_backward,
-	   								  "has-secondary-backward-stepper", &has_backward2, (char *)NULL );
-	gint magic = trough_border ? 1 : 0;
+    gtk_widget_style_get( gWidgetData[m_nScreen].gScrollHorizWidget, "has-forward-stepper", &has_forward,
+                                      "has-secondary-forward-stepper", &has_forward2,
+                                      "has-backward-stepper", &has_backward,
+                                      "has-secondary-backward-stepper", &has_backward2, (char *)NULL );
+    gint magic = trough_border ? 1 : 0;
     gint nFirst = 0;
 
     if ( has_backward )  nFirst  += 1;
     if ( has_forward2 )  nFirst  += 1;
 
-	if ( nPart == PART_DRAW_BACKGROUND_HORZ )
-	{
-		unsigned int sliderHeight = slider_width + (trough_border * 2);
-		vShim = (pixmapRect.GetHeight() - sliderHeight) / 2;
+    if ( nPart == PART_DRAW_BACKGROUND_HORZ )
+    {
+        unsigned int sliderHeight = slider_width + (trough_border * 2);
+        vShim = (pixmapRect.GetHeight() - sliderHeight) / 2;
 
-		scrollbarRect.Move( 0, vShim );
-		scrollbarRect.SetSize( Size( scrollbarRect.GetWidth(), sliderHeight ) );
+        scrollbarRect.Move( 0, vShim );
+        scrollbarRect.SetSize( Size( scrollbarRect.GetWidth(), sliderHeight ) );
 
-		scrollbarWidget = GTK_SCROLLBAR( gWidgetData[m_nScreen].gScrollHorizWidget );
-		scrollbarOrientation = GTK_ORIENTATION_HORIZONTAL;
-		scrollbarTag = scrollbarTagH;
-		button1Type = GTK_ARROW_LEFT;
-		button2Type = GTK_ARROW_RIGHT;
+        scrollbarWidget = GTK_SCROLLBAR( gWidgetData[m_nScreen].gScrollHorizWidget );
+        scrollbarOrientation = GTK_ORIENTATION_HORIZONTAL;
+        scrollbarTag = scrollbarTagH;
+        button1Type = GTK_ARROW_LEFT;
+        button2Type = GTK_ARROW_RIGHT;
 
         if ( has_backward )
         {
@@ -1542,33 +1547,33 @@
         button21BoundRect.SetSize( Size( stepper_size, slider_width ) );
         button22BoundRect.SetSize( Size( stepper_size, slider_width ) );
 
-		thumbRect.Bottom() = thumbRect.Top() + slider_width - 1;
-		// Make sure the thumb is at least the default width (so we don't get tiny thumbs),
-		// but if the VCL gives us a size smaller than the theme's default thumb size,
-		// honor the VCL size
+        thumbRect.Bottom() = thumbRect.Top() + slider_width - 1;
+        // Make sure the thumb is at least the default width (so we don't get tiny thumbs),
+        // but if the VCL gives us a size smaller than the theme's default thumb size,
+        // honor the VCL size
 #if 0
-		if ( (thumbRect.GetWidth() < min_slider_length)
-			&& ((scrollbarRect.GetWidth()-button1BoundRect.GetWidth()-button2BoundRect.GetWidth()) > min_slider_length) )
-			thumbRect.SetSize( Size( min_slider_length, thumbRect.GetHeight() ) );
+        if ( (thumbRect.GetWidth() < min_slider_length)
+            && ((scrollbarRect.GetWidth()-button1BoundRect.GetWidth()-button2BoundRect.GetWidth()) > min_slider_length) )
+            thumbRect.SetSize( Size( min_slider_length, thumbRect.GetHeight() ) );
 #endif
 
         thumbRect.Right() += magic;
-		// Center vertically in the track
-		thumbRect.Move( 0, (scrollbarRect.GetHeight() - slider_width) / 2 );
-	}
-	else
-	{
-		unsigned int sliderWidth = slider_width + (trough_border * 2);
-		hShim = (pixmapRect.GetWidth() - sliderWidth) / 2;
+        // Center vertically in the track
+        thumbRect.Move( 0, (scrollbarRect.GetHeight() - slider_width) / 2 );
+    }
+    else
+    {
+        unsigned int sliderWidth = slider_width + (trough_border * 2);
+        hShim = (pixmapRect.GetWidth() - sliderWidth) / 2;
 
-		scrollbarRect.Move( hShim, 0 );
-		scrollbarRect.SetSize( Size( sliderWidth, scrollbarRect.GetHeight() ) );
+        scrollbarRect.Move( hShim, 0 );
+        scrollbarRect.SetSize( Size( sliderWidth, scrollbarRect.GetHeight() ) );
 
-		scrollbarWidget = GTK_SCROLLBAR( gWidgetData[m_nScreen].gScrollVertWidget );
-		scrollbarOrientation = GTK_ORIENTATION_VERTICAL;
-		scrollbarTag = scrollbarTagV;
-		button1Type = GTK_ARROW_UP;
-		button2Type = GTK_ARROW_DOWN;
+        scrollbarWidget = GTK_SCROLLBAR( gWidgetData[m_nScreen].gScrollVertWidget );
+        scrollbarOrientation = GTK_ORIENTATION_VERTICAL;
+        scrollbarTag = scrollbarTagV;
+        button1Type = GTK_ARROW_UP;
+        button2Type = GTK_ARROW_DOWN;
 
         if ( has_backward )
         {
@@ -1577,7 +1582,7 @@
         }
         button11BoundRect.Move( (scrollbarRect.GetWidth() - slider_width) / 2, trough_border );
         button11BoundRect.SetSize( Size( slider_width, stepper_size ) );
-		button12BoundRect.SetSize( Size( slider_width, stepper_size ) );
+        button12BoundRect.SetSize( Size( slider_width, stepper_size ) );
 
         if ( has_backward2 )
         {
@@ -1592,41 +1597,41 @@
         button21BoundRect.SetSize( Size( slider_width, stepper_size ) );
         button22BoundRect.SetSize( Size( slider_width, stepper_size ) );
 
-		thumbRect.Right() = thumbRect.Left() + slider_width - 1;
+        thumbRect.Right() = thumbRect.Left() + slider_width - 1;
 #if 0
-		// Make sure the thumb is at least the default width (so we don't get tiny thumbs),
-		// but if the VCL gives us a size smaller than the theme's default thumb size,
-		// honor the VCL size
-		if ( (thumbRect.GetHeight() < min_slider_length)
-			&& ((scrollbarRect.GetHeight()-button1BoundRect.GetHeight()-button2BoundRect.GetHeight()) > min_slider_length) )
-			thumbRect.SetSize( Size( thumbRect.GetWidth(), min_slider_length ) );
+        // Make sure the thumb is at least the default width (so we don't get tiny thumbs),
+        // but if the VCL gives us a size smaller than the theme's default thumb size,
+        // honor the VCL size
+        if ( (thumbRect.GetHeight() < min_slider_length)
+            && ((scrollbarRect.GetHeight()-button1BoundRect.GetHeight()-button2BoundRect.GetHeight()) > min_slider_length) )
+            thumbRect.SetSize( Size( thumbRect.GetWidth(), min_slider_length ) );
 #endif
 
         thumbRect.Bottom() += magic;
-		// Center horizontally in the track
-		thumbRect.Move( (scrollbarRect.GetWidth() - slider_width) / 2, 0 );
-	}
+        // Center horizontally in the track
+        thumbRect.Move( (scrollbarRect.GetWidth() - slider_width) / 2, 0 );
+    }
 
     BOOL has_slider = ( thumbRect.GetWidth() > 0 && thumbRect.GetHeight() > 0 );
 
-	scrollbarValues = gtk_range_get_adjustment( GTK_RANGE(scrollbarWidget) );
-	if ( scrollbarValues == NULL )
-		scrollbarValues = GTK_ADJUSTMENT( gtk_adjustment_new(0, 0, 0, 0, 0, 0) );
-	if ( nPart == PART_DRAW_BACKGROUND_HORZ )
-	{
-		scrollbarValues->lower = pScrollbarVal->mnMin;
-		scrollbarValues->upper = pScrollbarVal->mnMax;
-		scrollbarValues->value = pScrollbarVal->mnCur;
-		scrollbarValues->page_size = scrollbarRect.GetWidth() / 2;
-	}
-	else
-	{
-		scrollbarValues->lower = pScrollbarVal->mnMin;
-		scrollbarValues->upper = pScrollbarVal->mnMax;
-		scrollbarValues->value = pScrollbarVal->mnCur;
-		scrollbarValues->page_size = scrollbarRect.GetHeight() / 2;
-	}
-	gtk_adjustment_changed( scrollbarValues );
+    scrollbarValues = gtk_range_get_adjustment( GTK_RANGE(scrollbarWidget) );
+    if ( scrollbarValues == NULL )
+        scrollbarValues = GTK_ADJUSTMENT( gtk_adjustment_new(0, 0, 0, 0, 0, 0) );
+    if ( nPart == PART_DRAW_BACKGROUND_HORZ )
+    {
+        scrollbarValues->lower = pScrollbarVal->mnMin;
+        scrollbarValues->upper = pScrollbarVal->mnMax;
+        scrollbarValues->value = pScrollbarVal->mnCur;
+        scrollbarValues->page_size = scrollbarRect.GetWidth() / 2;
+    }
+    else
+    {
+        scrollbarValues->lower = pScrollbarVal->mnMin;
+        scrollbarValues->upper = pScrollbarVal->mnMax;
+        scrollbarValues->value = pScrollbarVal->mnCur;
+        scrollbarValues->page_size = scrollbarRect.GetHeight() / 2;
+    }
+    gtk_adjustment_changed( scrollbarValues );
     
     // as multiple paints are required for the scrollbar
     // painting them directly to the window flickers
@@ -1641,81 +1646,81 @@
     GdkDrawable* const &gdkDrawable = GDK_DRAWABLE( pixmap );
     GdkRectangle* gdkRect = NULL; 
 
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
-	NWSetWidgetState( GTK_WIDGET(scrollbarWidget), nState, stateType );
-	NWSetWidgetState( gWidgetData[m_nScreen].gBtnWidget, nState, stateType );
-	style = GTK_WIDGET( scrollbarWidget )->style;
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    NWSetWidgetState( GTK_WIDGET(scrollbarWidget), nState, stateType );
+    NWSetWidgetState( gWidgetData[m_nScreen].gBtnWidget, nState, stateType );
+    style = GTK_WIDGET( scrollbarWidget )->style;
 
-	// ----------------- TROUGH
-	gtk_paint_flat_box( gWidgetData[m_nScreen].gBtnWidget->style, gdkDrawable, 
+    // ----------------- TROUGH
+    gtk_paint_flat_box( gWidgetData[m_nScreen].gBtnWidget->style, gdkDrawable, 
                         GTK_STATE_NORMAL, GTK_SHADOW_NONE, gdkRect,
                         m_pWindow, "base", x, y, 
                         w, h );
-	gtk_paint_box( style, gdkDrawable, GTK_STATE_ACTIVE, GTK_SHADOW_IN, 
+    gtk_paint_box( style, gdkDrawable, GTK_STATE_ACTIVE, GTK_SHADOW_IN, 
                    gdkRect, GTK_WIDGET(scrollbarWidget), "trough",
                    x, y,
                    scrollbarRect.GetWidth(), scrollbarRect.GetHeight() );
 
-	if ( nState & CTRL_STATE_FOCUSED )
-	{
-		gtk_paint_focus( style, gdkDrawable, GTK_STATE_ACTIVE, 
+    if ( nState & CTRL_STATE_FOCUSED )
+    {
+        gtk_paint_focus( style, gdkDrawable, GTK_STATE_ACTIVE, 
                          gdkRect, GTK_WIDGET(scrollbarWidget), "trough",
                          x, y,
                          scrollbarRect.GetWidth(), scrollbarRect.GetHeight() );
-	}
+    }
 
-	// ----------------- THUMB
+    // ----------------- THUMB
     if ( has_slider )
     {
-	    NWConvertVCLStateToGTKState( pScrollbarVal->mnThumbState, &stateType, &shadowType );
-	    if ( pScrollbarVal->mnThumbState & CTRL_STATE_PRESSED )  stateType = GTK_STATE_PRELIGHT;
-	    gtk_paint_slider( style, gdkDrawable, stateType, GTK_SHADOW_OUT, 
+        NWConvertVCLStateToGTKState( pScrollbarVal->mnThumbState, &stateType, &shadowType );
+        if ( pScrollbarVal->mnThumbState & CTRL_STATE_PRESSED )  stateType = GTK_STATE_PRELIGHT;
+        gtk_paint_slider( style, gdkDrawable, stateType, GTK_SHADOW_OUT, 
                         gdkRect, GTK_WIDGET(scrollbarWidget), "slider",
                         x+hShim+thumbRect.Left(), y+vShim+thumbRect.Top(), 
                         thumbRect.GetWidth(), thumbRect.GetHeight(), scrollbarOrientation );
     }
-	// ----------------- BUTTON 1 //
-	if ( has_backward )
-	{
+    // ----------------- BUTTON 1 //
+    if ( has_backward )
+    {
         NWConvertVCLStateToGTKState( pScrollbarVal->mnButton1State, &stateType, &shadowType );
-        if ( stateType == GTK_STATE_INSENSITIVE )	stateType = GTK_STATE_NORMAL;
+        if ( stateType == GTK_STATE_INSENSITIVE )   stateType = GTK_STATE_NORMAL;
         gtk_paint_box( style, gdkDrawable, stateType, shadowType, 
                        gdkRect, GTK_WIDGET(scrollbarWidget), "stepper",
                        x+hShim+button11BoundRect.Left(), y+vShim+button11BoundRect.Top(), 
                        button11BoundRect.GetWidth(), button11BoundRect.GetHeight() );
         // ----------------- ARROW 1
-    	NWCalcArrowRect( button11BoundRect, arrowRect );
-    	gtk_paint_arrow( style, gdkDrawable, stateType, shadowType, 
+        NWCalcArrowRect( button11BoundRect, arrowRect );
+        gtk_paint_arrow( style, gdkDrawable, stateType, shadowType, 
                          gdkRect, GTK_WIDGET(scrollbarWidget), scrollbarTag, button1Type, TRUE,
                          x+hShim+arrowRect.Left(), y+vShim+arrowRect.Top(), 
                          arrowRect.GetWidth(), arrowRect.GetHeight() );
     }
-	if ( has_forward2 )
-	{
+    if ( has_forward2 )
+    {
         NWConvertVCLStateToGTKState( pScrollbarVal->mnButton2State, &stateType, &shadowType );
-        if ( stateType == GTK_STATE_INSENSITIVE )	stateType = GTK_STATE_NORMAL;
+        if ( stateType == GTK_STATE_INSENSITIVE )   stateType = GTK_STATE_NORMAL;
         gtk_paint_box( style, gdkDrawable, stateType, shadowType, 
                        gdkRect, GTK_WIDGET(scrollbarWidget), "stepper",
                        x+hShim+button12BoundRect.Left(), y+vShim+button12BoundRect.Top(), 
                        button12BoundRect.GetWidth(), button12BoundRect.GetHeight() );
         // ----------------- ARROW 1
-    	NWCalcArrowRect( button12BoundRect, arrowRect );
-    	gtk_paint_arrow( style, gdkDrawable, stateType, shadowType, 
+        NWCalcArrowRect( button12BoundRect, arrowRect );
+        gtk_paint_arrow( style, gdkDrawable, stateType, shadowType, 
                          gdkRect, GTK_WIDGET(scrollbarWidget), scrollbarTag, button2Type, TRUE,
                          x+hShim+arrowRect.Left(), y+vShim+arrowRect.Top(), 
                          arrowRect.GetWidth(), arrowRect.GetHeight() );
     }
-	// ----------------- BUTTON 2
+    // ----------------- BUTTON 2
     if ( has_backward2 )
     {
         NWConvertVCLStateToGTKState( pScrollbarVal->mnButton1State, &stateType, &shadowType );
-        if ( stateType == GTK_STATE_INSENSITIVE )	stateType = GTK_STATE_NORMAL;
+        if ( stateType == GTK_STATE_INSENSITIVE )   stateType = GTK_STATE_NORMAL;
         gtk_paint_box( style, gdkDrawable, stateType, shadowType, gdkRect, 
                        GTK_WIDGET(scrollbarWidget), "stepper",
                        x+hShim+button21BoundRect.Left(), y+vShim+button21BoundRect.Top(), 
                        button21BoundRect.GetWidth(), button21BoundRect.GetHeight() );
-    	// ----------------- ARROW 2
-    	NWCalcArrowRect( button21BoundRect, arrowRect );
+        // ----------------- ARROW 2
+        NWCalcArrowRect( button21BoundRect, arrowRect );
         gtk_paint_arrow( style, gdkDrawable, stateType, shadowType, 
                          gdkRect, GTK_WIDGET(scrollbarWidget), scrollbarTag, button1Type, TRUE,
                          x+hShim+arrowRect.Left(), y+vShim+arrowRect.Top(), 
@@ -1724,13 +1729,13 @@
     if ( has_forward )
     {
         NWConvertVCLStateToGTKState( pScrollbarVal->mnButton2State, &stateType, &shadowType );
-        if ( stateType == GTK_STATE_INSENSITIVE )	stateType = GTK_STATE_NORMAL;
+        if ( stateType == GTK_STATE_INSENSITIVE )   stateType = GTK_STATE_NORMAL;
         gtk_paint_box( style, gdkDrawable, stateType, shadowType, gdkRect, 
                        GTK_WIDGET(scrollbarWidget), "stepper",
                        x+hShim+button22BoundRect.Left(), y+vShim+button22BoundRect.Top(), 
                        button22BoundRect.GetWidth(), button22BoundRect.GetHeight() );
-    	// ----------------- ARROW 2
-    	NWCalcArrowRect( button22BoundRect, arrowRect );
+        // ----------------- ARROW 2
+        NWCalcArrowRect( button22BoundRect, arrowRect );
         gtk_paint_arrow( style, gdkDrawable, stateType, shadowType, 
                          gdkRect, GTK_WIDGET(scrollbarWidget), scrollbarTag, button2Type, TRUE,
                          x+hShim+arrowRect.Left(), y+vShim+arrowRect.Top(), 
@@ -1744,12 +1749,12 @@
     }
     g_object_unref( pixmap );
  
-	return( TRUE );
+    return( TRUE );
 }
 
 //---
 
-static Rectangle NWGetScrollButtonRect(	int nScreen, ControlPart nPart, Rectangle aAreaRect )
+static Rectangle NWGetScrollButtonRect( int nScreen, ControlPart nPart, Rectangle aAreaRect )
 {
     gint slider_width;
     gint stepper_size;
@@ -1758,26 +1763,26 @@
 
     NWEnsureGTKScrollbars( nScreen );
 
-	// Grab some button style attributes
-	gtk_widget_style_get( gWidgetData[nScreen].gScrollHorizWidget,
+    // Grab some button style attributes
+    gtk_widget_style_get( gWidgetData[nScreen].gScrollHorizWidget,
                                       "slider-width", &slider_width,
-									  "stepper-size", &stepper_size,
-									  "trough-border", &trough_border,
-	   								  "stepper-spacing", &stepper_spacing, (char *)NULL );
+                                      "stepper-size", &stepper_size,
+                                      "trough-border", &trough_border,
+                                      "stepper-spacing", &stepper_spacing, (char *)NULL );
 
     gboolean has_forward;
     gboolean has_forward2;
     gboolean has_backward;
     gboolean has_backward2;
 
-	gtk_widget_style_get( gWidgetData[nScreen].gScrollHorizWidget,
+    gtk_widget_style_get( gWidgetData[nScreen].gScrollHorizWidget,
                                       "has-forward-stepper", &has_forward,
-									  "has-secondary-forward-stepper", &has_forward2,
-									  "has-backward-stepper", &has_backward,
-	   								  "has-secondary-backward-stepper", &has_backward2, (char *)NULL );
-	gint       buttonWidth;
-	gint       buttonHeight;
-	Rectangle  buttonRect;
+                                      "has-secondary-forward-stepper", &has_forward2,
+                                      "has-backward-stepper", &has_backward,
+                                      "has-secondary-backward-stepper", &has_backward2, (char *)NULL );
+    gint       buttonWidth;
+    gint       buttonHeight;
+    Rectangle  buttonRect;
 
     gint nFirst = 0;
     gint nSecond = 0;
@@ -1827,7 +1832,7 @@
 
     buttonRect.SetSize( Size( buttonWidth, buttonHeight ) );
 
-	return( buttonRect );
+    return( buttonRect );
 }
 
 //-------------------------------------
@@ -1840,7 +1845,7 @@
                                         const ImplControlValue& aValue,
                                         const OUString& rCaption )
 {
-	Rectangle		pixmapRect;
+    Rectangle       pixmapRect;
     GdkRectangle    clipRect;
     
 	// Find the overall bounding rect of the buttons's drawing area,
@@ -1857,7 +1862,7 @@
         NWPaintOneEditBox( m_nScreen, gdkDrawable, &clipRect, nType, nPart, pixmapRect, nState, aValue, rCaption );
     }
 
-	return( TRUE );
+    return( TRUE );
 }
 
 
@@ -1867,31 +1872,31 @@
  */
 static Rectangle NWGetEditBoxPixmapRect(int nScreen,
                                         ControlType,
-								        ControlPart,
+                                        ControlPart,
                                         Rectangle aAreaRect,
                                         ControlState,
                                         const ImplControlValue&,
                                         const OUString& )
 {
-	Rectangle		pixmapRect = aAreaRect;
-	gboolean		interiorFocus;
-	gint			focusWidth;
-
-	NWEnsureGTKEditBox( nScreen );
-
-	// Grab some entry style attributes
-	gtk_widget_style_get( gWidgetData[nScreen].gEditBoxWidget,
-                                	"focus-line-width",	&focusWidth,
-					 				"interior-focus",	&interiorFocus, (char *)NULL );
+    Rectangle       pixmapRect = aAreaRect;
+    gboolean        interiorFocus;
+    gint            focusWidth;
 
-	if ( !interiorFocus )
-	{
-		pixmapRect.Move( -(focusWidth), -(focusWidth) );
+    NWEnsureGTKEditBox( nScreen );
+
+    // Grab some entry style attributes
+    gtk_widget_style_get( gWidgetData[nScreen].gEditBoxWidget,
+                                    "focus-line-width", &focusWidth,
+                                    "interior-focus",   &interiorFocus, (char *)NULL );
+
+    if ( !interiorFocus )
+    {
+        pixmapRect.Move( -(focusWidth), -(focusWidth) );
         pixmapRect.SetSize( Size( pixmapRect.GetWidth() + (2*(focusWidth)),
                                   pixmapRect.GetHeight() + (2*(focusWidth)) ) );
-	}
+    }
 
-	return( pixmapRect );
+    return( pixmapRect );
 }
 
 
@@ -1899,67 +1904,66 @@
  * All coordinates should be local to the Pixmap, NOT
  * screen/window coordinates.
  */
-static void NWPaintOneEditBox(	int nScreen,
+static void NWPaintOneEditBox(  int nScreen,
                                 GdkDrawable * gdkDrawable,
-                                GdkRectangle *	gdkRect,
-                                ControlType			nType,
+                                GdkRectangle *  gdkRect,
+                                ControlType         nType,
                                 ControlPart,
-                                Rectangle				aEditBoxRect,
-                                ControlState			nState,
+                                Rectangle               aEditBoxRect,
+                                ControlState            nState,
                                 const ImplControlValue&,
                                 const OUString& )
 {
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
-	GtkWidget      *widget;
-
-	NWEnsureGTKButton( nScreen );
-	NWEnsureGTKEditBox( nScreen );
-	NWEnsureGTKSpinButton( nScreen );
-	NWEnsureGTKCombo( nScreen );
-	NWEnsureGTKScrolledWindow( nScreen );
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
+    GtkWidget      *widget;
+
+    NWEnsureGTKButton( nScreen );
+    NWEnsureGTKEditBox( nScreen );
+    NWEnsureGTKSpinButton( nScreen );
+    NWEnsureGTKComboBoxEntry( nScreen );
+    NWEnsureGTKScrolledWindow( nScreen );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
 
     /* border's shadowType for gtk entries is always GTK_SHADOW_IN (see gtkentry.c)
     shadowType = GTK_SHADOW_IN;
     */
     
-	switch ( nType )
-	{
-		case CTRL_SPINBOX:
-			widget = gWidgetData[nScreen].gSpinButtonWidget;
-			break;
-
+    switch ( nType )
+    {
+        case CTRL_SPINBOX:
+            widget = gWidgetData[nScreen].gSpinButtonWidget;
+            break;
         case CTRL_MULTILINE_EDITBOX:
             widget = gWidgetData[nScreen].gScrolledWindowWidget;
             break;
-		case CTRL_COMBOBOX:
-			widget = GTK_COMBO(gWidgetData[nScreen].gComboWidget)->entry;
-			break;
-
-		default:
-			widget = gWidgetData[nScreen].gEditBoxWidget;
-			break;
-	}
+        case CTRL_LISTBOX:
+        case CTRL_COMBOBOX:
+            widget = gWidgetData[nScreen].gComboBoxEntry_EntryWidget;
+            break;
+        default:
+            widget = gWidgetData[nScreen].gEditBoxWidget;
+            break;
+    }
 
-	if ( stateType == GTK_STATE_PRELIGHT )
-		stateType = GTK_STATE_NORMAL;
+    if ( stateType == GTK_STATE_PRELIGHT )
+        stateType = GTK_STATE_NORMAL;
 
-	// Blueprint needs to paint entry_bg with a Button widget, not an Entry widget to get
-	// a nice white (or whatever default color) background
+    // Blueprint needs to paint entry_bg with a Button widget, not an Entry widget to get
+    // a nice white (or whatever default color) background
     GtkWidget* pBGWidget = widget;
     if( GtkSalGraphics::bNeedButtonStyleAsEditBackgroundWorkaround )
     {
         NWSetWidgetState( gWidgetData[nScreen].gBtnWidget, nState, stateType );
         pBGWidget = gWidgetData[nScreen].gBtnWidget;
     }
-	NWSetWidgetState( widget, nState, stateType );
+    NWSetWidgetState( widget, nState, stateType );
 
-	gtk_paint_flat_box( pBGWidget->style, gdkDrawable, stateType, GTK_SHADOW_NONE, 
+    gtk_paint_flat_box( pBGWidget->style, gdkDrawable, stateType, GTK_SHADOW_NONE, 
                         gdkRect, pBGWidget, "entry_bg",
                         aEditBoxRect.Left(), aEditBoxRect.Top(), 
                         aEditBoxRect.GetWidth(), aEditBoxRect.GetHeight() );
-	gtk_paint_shadow( widget->style, gdkDrawable, GTK_STATE_NORMAL, GTK_SHADOW_IN, 
+    gtk_paint_shadow( widget->style, gdkDrawable, GTK_STATE_NORMAL, GTK_SHADOW_IN, 
                       gdkRect, widget, "entry",
                       aEditBoxRect.Left(), aEditBoxRect.Top(), 
                       aEditBoxRect.GetWidth(), aEditBoxRect.GetHeight() );
@@ -2068,33 +2072,33 @@
 
 static Rectangle NWGetSpinButtonRect( int nScreen,
                                       ControlType,
-								      ControlPart			nPart,
-                                      Rectangle 			aAreaRect,
+                                      ControlPart           nPart,
+                                      Rectangle             aAreaRect,
                                       ControlState,
                                       const ImplControlValue&,
                                       const OUString& )
 {
-	gint			buttonSize;
-	Rectangle		buttonRect;
+    gint            buttonSize;
+    Rectangle       buttonRect;
 
-	NWEnsureGTKSpinButton( nScreen );
+    NWEnsureGTKSpinButton( nScreen );
 
-	buttonSize = MAX( PANGO_PIXELS( pango_font_description_get_size(GTK_WIDGET(gWidgetData[nScreen].gSpinButtonWidget)->style->font_desc) ),
-				   MIN_SPIN_ARROW_WIDTH );
-	buttonSize -= buttonSize % 2 - 1; /* force odd */
-	buttonRect.SetSize( Size( buttonSize + 2 * gWidgetData[nScreen].gSpinButtonWidget->style->xthickness,
+    buttonSize = MAX( PANGO_PIXELS( pango_font_description_get_size(GTK_WIDGET(gWidgetData[nScreen].gSpinButtonWidget)->style->font_desc) ),
+                   MIN_SPIN_ARROW_WIDTH );
+    buttonSize -= buttonSize % 2 - 1; /* force odd */
+    buttonRect.SetSize( Size( buttonSize + 2 * gWidgetData[nScreen].gSpinButtonWidget->style->xthickness,
                               buttonRect.GetHeight() ) );
-	buttonRect.setX( aAreaRect.Left() + (aAreaRect.GetWidth() - buttonRect.GetWidth()) );
-	if ( nPart == PART_BUTTON_UP )
-	{
-		buttonRect.setY( aAreaRect.Top() );
-		buttonRect.Bottom() = buttonRect.Top() + (aAreaRect.GetHeight() / 2);
-	}
-	else if( nPart == PART_BUTTON_DOWN )
-	{
-		buttonRect.setY( aAreaRect.Top() + (aAreaRect.GetHeight() / 2) );
-		buttonRect.Bottom() = aAreaRect.Bottom(); // cover area completely
-	}
+    buttonRect.setX( aAreaRect.Left() + (aAreaRect.GetWidth() - buttonRect.GetWidth()) );
+    if ( nPart == PART_BUTTON_UP )
+    {
+        buttonRect.setY( aAreaRect.Top() );
+        buttonRect.Bottom() = buttonRect.Top() + (aAreaRect.GetHeight() / 2);
+    }
+    else if( nPart == PART_BUTTON_DOWN )
+    {
+        buttonRect.setY( aAreaRect.Top() + (aAreaRect.GetHeight() / 2) );
+        buttonRect.Bottom() = aAreaRect.Bottom(); // cover area completely
+    }
     else
     {
         buttonRect.Right()  = buttonRect.Left()-1;
@@ -2103,7 +2107,7 @@
         buttonRect.Bottom() = aAreaRect.Bottom();
     }
 
-	return( buttonRect );
+    return( buttonRect );
 }
 
 //---
@@ -2137,22 +2141,24 @@
 	arrowSize = (buttonRect.GetWidth() - (2 * gWidgetData[nScreen].gSpinButtonWidget->style->xthickness)) - 4;
 	arrowSize -= arrowSize % 2 - 1; /* force odd */
     arrowRect.SetSize( Size( arrowSize, arrowSize ) );
-	arrowRect.setX( buttonRect.Left() + (buttonRect.GetWidth() - arrowRect.GetWidth()) / 2 );
-	if ( nPart == PART_BUTTON_UP )
-		arrowRect.setY( buttonRect.Top() + (buttonRect.GetHeight() - arrowRect.GetHeight()) / 2 + 1);
-	else
-		arrowRect.setY( buttonRect.Top() + (buttonRect.GetHeight() - arrowRect.GetHeight()) / 2 - 1);
+    arrowRect.setX( buttonRect.Left() + (buttonRect.GetWidth() - arrowRect.GetWidth()) / 2 );
+    if ( nPart == PART_BUTTON_UP )
+        arrowRect.setY( buttonRect.Top() + (buttonRect.GetHeight() - arrowRect.GetHeight()) / 2 + 1);
+    else
+        arrowRect.setY( buttonRect.Top() + (buttonRect.GetHeight() - arrowRect.GetHeight()) / 2 - 1);
 
-	gtk_paint_arrow( gWidgetData[nScreen].gSpinButtonWidget->style, pixmap, stateType, GTK_SHADOW_OUT, NULL, gWidgetData[nScreen].gSpinButtonWidget,
-			"spinbutton", (nPart == PART_BUTTON_UP) ? GTK_ARROW_UP : GTK_ARROW_DOWN, TRUE,
-			(arrowRect.Left() - aAreaRect.Left()), (arrowRect.Top() - aAreaRect.Top()),
-			arrowRect.GetWidth(), arrowRect.GetHeight() );
+    gtk_paint_arrow( gWidgetData[nScreen].gSpinButtonWidget->style, pixmap, stateType, GTK_SHADOW_OUT, NULL, gWidgetData[nScreen].gSpinButtonWidget,
+            "spinbutton", (nPart == PART_BUTTON_UP) ? GTK_ARROW_UP : GTK_ARROW_DOWN, TRUE,
+            (arrowRect.Left() - aAreaRect.Left()), (arrowRect.Top() - aAreaRect.Top()),
+            arrowRect.GetWidth(), arrowRect.GetHeight() );
 }
 
 
 //-------------------------------------
 
-BOOL GtkSalGraphics::NWPaintGTKComboBox( GdkDrawable* gdkDrawable,
+#define ARROW_EXTENT        0.7
+
+BOOL GtkSalGraphics::NWPaintGTKComboBoxEntry( GdkDrawable* gdkDrawable,
                                          ControlType nType, ControlPart nPart,
                                          const Rectangle& rControlRectangle,
                                          const clipList& rClipList,
